"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const express = require('express');
const index_1 = require('../index');
let app = express();
class HelloCtrl extends index_1.CCController {
    helloWorld(req, res) {
        return 'helloWorld';
    }
    helloWorldAsync(req, res) {
        return new Promise((resolve) => {
            setTimeout(function () {
                resolve({ value: 'hello async' });
            }, 200);
        });
    }
    errorWorldAsync(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield new Promise((resolve, reject) => {
                setTimeout(function () {
                    reject('I just crashed in error world');
                }, 200);
            });
        });
    }
}
__decorate([
    index_1.get('/hello')
], HelloCtrl.prototype, "helloWorld", null);
__decorate([
    index_1.get('/async')
], HelloCtrl.prototype, "helloWorldAsync", null);
__decorate([
    index_1.get('/async-error')
], HelloCtrl.prototype, "errorWorldAsync", null);
const ctrl = new HelloCtrl();
app.use('/', ctrl.router);
app.use('/hello', ctrl.router);
app.listen(3000);
